#include "StdAfx.h"
#include "RegMon.h"
#include <atlbase.h>

CRegMon::CRegMon()
{
	m_hWnd = NULL ;
	for (int nIndex = 0; nIndex < CHECK_EVENT_NUMBER; nIndex++)
		m_hEvent[nIndex] = NULL ;
	m_hThread = HANDLE(-1) ;
	m_Impl = NULL; // [:2008-11-25] ʱȭ ؾ 
	m_pCrit = NULL;
}

CRegMon::~CRegMon()
{
	Finalize() ;
}

//		protected/static

BOOL CRegMon::WaitNotifyEvent(const CRegMon *regmon)
{
	BOOL ret = TRUE;
	BOOL bPrevEngineIsNaver = regmon->m_Impl->IsCoreValue();//IsSearchProviderIsNaver();

	DWORD dwResult = ::WaitForMultipleObjects(2, &regmon->m_hEvent[0], FALSE, INFINITE) ;
	switch (dwResult)
	{
	case WAIT_OBJECT_0 :
		{
			::PostMessage(regmon->m_hWnd, regmon->m_RegInfo.m_NotifyMessage, bPrevEngineIsNaver, 0);
			break ;
		}
	case WAIT_OBJECT_0 + 1 :
		{
			ATLTRACE(_T("WAIT_DONE\n")) ;
			ret = FALSE ;
			break ;
		}
	default :
		{
			ret = FALSE ;
			break ;
		}
	}

	return ret;
}

void CRegMon::Continue()
{
	SetEvent( m_hEvent[2] );
}

BOOL CRegMon::WaitContinueEvent(const CRegMon *regmon)
{
	BOOL ret = TRUE;
	HANDLE continueEvent[2];
	continueEvent[0] = regmon->m_hEvent[2];
	continueEvent[1] = regmon->m_hEvent[1];
	DWORD dwResult = ::WaitForMultipleObjects(2, continueEvent, FALSE, INFINITE);
	switch(dwResult)
	{
	case WAIT_OBJECT_0 :
		{
			break;
		}
	case WAIT_OBJECT_0 + 1 :
		{
			ATLTRACE(_T("WAIT_DONE\n")) ;
			ret = FALSE ;
			break;
		}
	default :
		{
			ret = FALSE ;
			break ;
		}
	}

	return ret;
}

unsigned CRegMon::RegNotifyChangeProc(void *pvParam)
{
	CRegMon *pThis = reinterpret_cast<CRegMon *>(pvParam) ;
	LONG lResult = 0 ;
	CRegKey RegKey;
	lResult = RegKey.Open(pThis->m_RegInfo.m_hKey/*HKEY_CURRENT_USER*/, pThis->m_RegInfo.m_RegPath/*SUBKEY_SEARCH_SCOPES*/, KEY_NOTIFY) ;
	if (lResult != ERROR_SUCCESS)
		return unsigned(-1) ;
	DWORD dwResult = 0 ;

	while (TRUE)
	{
		if( FALSE == WaitContinueEvent(pThis) )
			break;

		lResult = ::RegNotifyChangeKeyValue(RegKey, FALSE, REG_NOTIFY_CHANGE_LAST_SET, pThis->m_hEvent[0], TRUE) ;

		if (lResult != ERROR_SUCCESS)
			break ;

		if( FALSE == WaitNotifyEvent( pThis ) )
			break;
	}

	RegKey.Close() ;
	return 0 ;
}


//		public

bool CRegMon::Initialize(HWND hWnd, HKEY hKey, UINT notifyMessage, LPCTSTR RegPath, IObserver *pImpl)
{
	uintptr_t uThread = uintptr_t(-1) ;
	unsigned uThreadId = 0 ;
	m_hWnd = hWnd ;
	for (int nIndex = 0; nIndex < CHECK_EVENT_NUMBER; nIndex++)
		m_hEvent[nIndex] = ::CreateEvent(NULL, FALSE, FALSE, NULL) ;
	uThread = _beginthreadex(NULL, 0, RegNotifyChangeProc, this, 0, &uThreadId) ;
	m_hThread = reinterpret_cast<HANDLE>(uThread) ;


	m_RegInfo.m_hKey = hKey;
	m_RegInfo.m_NotifyMessage = notifyMessage;
	_tcscpy_s(m_RegInfo.m_RegPath, MAX_PATH, RegPath);

	m_Impl = pImpl;
	m_pCrit = new CRITICAL_SECTION;
	InitializeCriticalSection(m_pCrit);
	SetEvent(m_hEvent[2]);
	return true ;
}

void CRegMon::Finalize()
{
	if (m_hThread != HANDLE(-1))
	{
		if (m_hEvent[1] != NULL)
			::SetEvent(m_hEvent[1]) ;
		::WaitForSingleObject(m_hThread, 1000) ;
		::CloseHandle(m_hThread) ;
		m_hThread = HANDLE(-1) ;
	}
	for (int nIndex = 0; nIndex < CHECK_EVENT_NUMBER; nIndex++)
	{
		if (m_hEvent[nIndex] != NULL)
		{
			::CloseHandle(m_hEvent[nIndex]) ;
			m_hEvent[nIndex] = NULL ;
		}
	}

	if (m_Impl)
		delete m_Impl;
	m_Impl = NULL;

	if( m_pCrit )
	{
		DeleteCriticalSection(m_pCrit);
		delete m_pCrit;
		m_pCrit = NULL;
	}
}
